<?php
class floOS
{
	var $is_nutd = array();
	function floOS_version_compare($a, $b)
	{
	$pattern = array('/([a-z])/ei', '/\.+/', '/\.\Z|\A\./');
	$replacement = array( "'.'.intval('\\1', 36).'.'", '.', '');
	
	$array = preg_replace($pattern, $replacement, array($a, $b));
	
	return version_compare($array[0], $array[1], '>=');
	}
	function theme_version_search($dir)
	{
	global $template, $page;
	load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
	$header_msgs = array();
	$dh = opendir ($dir);
	while (($file = readdir ($dh)) !== false ) {
		if ($file !== '.' && $file !== '..' && $file !== '.svn') { // enleve svn
			$path =$dir.'/'.$file;
			if (is_dir($path)) {
				$this->theme_version_search($path);
			}
			else
			{
			  $page = explode('.', $file);
			  $nb = count($page);
			  $nom_fichier = $page[0];
			  for ($i = 1; $i < $nb-1; $i++){
			   $nom_fichier .= '.'.$page[$i];
			  }
			  if(isset($page[1])){
			   $ext_fichier = $page[$nb-1];
			  }
			  else {
			   $ext_fichier = '';
			  }
			  if($nom_fichier == 'themeconf.inc' and $ext_fichier == 'php') {
				  include($path);
				  if (isset($themeconf['eid']))
				  {
					  if($this->is_not_up_to_date($themeconf['version'],$themeconf['eid']) )
					  {
						  
						  $msg=l10n('theme_update_needed_1').$themeconf['theme'].l10n('theme_update_needed_2').$themeconf['eid'].l10n('theme_update_needed_3').$themeconf['theme'].l10n('theme_update_needed_4');
						  $template->append('header_notes', $msg);
						  $this->is_nutd[$themeconf['theme']]=$themeconf['version'];
					  }
				  }
					  
			  }
			}
		}
	}
	closedir ($dh); // on ferme le repertoire courant
	}
	function url_is_remote($url)
	{
	  if ( strncmp($url, 'http://', 7)==0
		or strncmp($url, 'https://', 8)==0 )
	  {
		return true;
	  }
	  return false;
	}
	
	function fetchRemote($src, &$dest, $user_agent='Piwigo', $step=0)
	{
	  // Try to retrieve data from local file?
	  if (!$this->url_is_remote($src))
	  {
		$content = @file_get_contents($src);
		if ($content !== false)
		{
		  is_resource($dest) ? @fwrite($dest, $content) : $dest = $content;
		  return true;
		}
		else
		{
		  return false;
		}
	  }
	
	  // After 3 redirections, return false
	  if ($step > 3) return false;
	
	  // Initialize $dest
	  is_resource($dest) or $dest = '';
	
	  // Try curl to read remote file
	  if (function_exists('curl_init'))
	  {
		$ch = @curl_init();
		@curl_setopt($ch, CURLOPT_URL, $src);
		@curl_setopt($ch, CURLOPT_HEADER, 1);
		@curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
		@curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$content = @curl_exec($ch);
		$header_length = @curl_getinfo($ch, CURLINFO_HEADER_SIZE);
		$status = @curl_getinfo($ch, CURLINFO_HTTP_CODE);
		@curl_close($ch);
		if ($content !== false and $status >= 200 and $status < 400)
		{
		  if (preg_match('/Location:\s+?(.+)/', substr($content, 0, $header_length), $m))
		  {
			return $this->fetchRemote($m[1], $dest, $user_agent, $step+1);
		  }
		  $content = substr($content, $header_length);
		  is_resource($dest) ? @fwrite($dest, $content) : $dest = $content;
		  return true;
		}
	  }
	
	  // Try file_get_contents to read remote file
	  if (ini_get('allow_url_fopen'))
	  {
		$content = @file_get_contents($src);
		if ($content !== false)
		{
		  is_resource($dest) ? @fwrite($dest, $content) : $dest = $content;
		  return true;
		}
	  }
	
	  // Try fsockopen to read remote file
	  $src = parse_url($src);
	  $host = $src['host'];
	  $path = isset($src['path']) ? $src['path'] : '/';
	  $path .= isset($src['query']) ? '?'.$src['query'] : '';
	
	  if (($s = @fsockopen($host,80,$errno,$errstr,5)) === false)
	  {
		return false;
	  }
	
	  fwrite($s,
		"GET ".$path." HTTP/1.0\r\n"
		."Host: ".$host."\r\n"
		."User-Agent: ".$user_agent."\r\n"
		."Accept: */*\r\n"
		."\r\n"
	  );
	
	  $i = 0;
	  $in_content = false;
	  while (!feof($s))
	  {
		$line = fgets($s);
	
		if (rtrim($line,"\r\n") == '' && !$in_content)
		{
		  $in_content = true;
		  $i++;
		  continue;
		}
		if ($i == 0)
		{
		  if (!preg_match('/HTTP\/(\\d\\.\\d)\\s*(\\d+)\\s*(.*)/',rtrim($line,"\r\n"), $m))
		  {
			fclose($s);
			return false;
		  }
		  $status = (integer) $m[2];
		  if ($status < 200 || $status >= 400)
		  {
			fclose($s);
			return false;
		  }
		}
		if (!$in_content)
		{
		  if (preg_match('/Location:\s+?(.+)$/',rtrim($line,"\r\n"),$m))
		  {
			fclose($s);
			return $this->fetchRemote(trim($m[1]),$dest,$user_agent,$step+1);
		  }
		  $i++;
		  continue;
		}
		is_resource($dest) ? @fwrite($dest, $line) : $dest .= $line;
		$i++;
	  }
	  fclose($s);
	  return true;
	}


	function is_not_up_to_date($v_local, $eid)
	{
	
	global $template, $user, $page;
//	include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');

	load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
	
	// Retrieve PEM versions
	$version = PHPWG_VERSION;
	$versions_to_check = array();
	$url = PEM_URL . '/api/get_version_list.php?category_id=12&format=php';
	if ($this->fetchRemote($url, $result) and $pem_versions = @unserialize($result))
	{
	  if (!preg_match('/^\d+\.\d+\.\d+/', $version))
	  {
		$version = $pem_versions[0]['name'];
	  }
	  $branch = substr($version, 0, strrpos($version, '.'));
	  foreach ($pem_versions as $pem_version)
	  {
		if (strpos($pem_version['name'], $branch) === 0)
		{
		  $versions_to_check[] = $pem_version['id'];
		}
	  }
	}
	
	// Retrieve PEM template infos
	$url = PEM_URL . '/api/get_revision_list.php?format=php&last_revision_only=true';
	$url .= '&version=' . implode(',', $versions_to_check);
	//$url .= '&lang=' . substr($user['language'], 0, 2);
	$url .= '&extension_include='.$eid;
	$this->fetchRemote($url, $result);
	  $pem_res = @unserialize($result);
	  foreach($pem_res as $pem_floOS)
	  {
		  if (!is_array($pem_floOS))
		  {
			$template->assign(
				array(
				  'erreur' => 'erreur url : '.$url,
				)
			  );
		  }
		if (!$this->floOS_version_compare($v_local, $pem_floOS['revision_name']))
		{
			  return true;
		}
		else
		{
			return false;
		}
	  }
	}
	function display($names)
	{
		if (!is_array($names))
		{
			global $template;
			$template->assign(
				array(
					'erreur' => 'erreur get session var not array',
				)
			);
		}
		else
		{
			global $template, $user;
			load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
			$r_names=$names;
			foreach($names as $name => $version)
			{
				if ($name=='floOS')
				{
					include(PHPWG_ROOT_PATH.'template/floOS/tools/version.conf.php');
					if ($this->floOS_version_compare($version, $floOS_conf['version']))
					{
						$template->append('header_notes', l10n('floOS_update_needed'));
					}
					else
					{
						$p=array_search($name,array_keys($r_names));
						array_splice ($r_names,$p,1);
					}
					
				}
				else
				{
					if ( is_dir(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name) and is_file(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name.'/themeconf.inc.php') )
					{
						include(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name.'/themeconf.inc.php');
						if ($this->floOS_version_compare($version, $themeconf['version']))
						{
							$msg=l10n('theme_update_needed_1').$themeconf['theme'].l10n('theme_update_needed_2').$themeconf['eid'].l10n('theme_update_needed_3').$themeconf['theme'].l10n('theme_update_needed_4');
							$template->append('header_notes', $msg);
						}
						else
						{
							$p=array_search($name,array_keys($r_names));
							array_splice ($r_names,$p,1);
						}
					}
				}
			}
		}//else
		
	pwg_set_session_var('floOS_array_version',$r_names);
	}
}
?>